package org.zheng.demo;

import static org.junit.jupiter.api.Assertions.assertThrows;

import java.util.NoSuchElementException;
import java.util.Scanner;

import org.junit.jupiter.api.Test;

class CloseScannerTest {

	@Test
	void throwIllegalStateExceptionOnReuseClosedScanner() {
		Scanner scanner = new Scanner(System.in);
		System.out.println("Enter a name:");

		String name = scanner.nextLine();
		System.out.printf("Hello %s!", name);

		// add close at the last statement
		scanner.close();
		// The System.in is InputStream class that implements Closeable
		assertThrows(IllegalStateException.class, scanner::nextInt);

	}

	@Test
	void throwNoSuchElementExceptionOnNewScannerWithClosedSystemIn() {
		Scanner scanner = new Scanner(System.in);
		System.out.println("Enter a name:");

		String name = scanner.nextLine();
		System.out.printf("Hello %s!", name);

		// add close at the last statement
		scanner.close();// this close the System.in as it implements Closeable
		Scanner scanner2 = new Scanner(System.in);
		assertThrows(NoSuchElementException.class, scanner2::nextInt);
		scanner2.close();
	}

}
